public class Pi {
    public static void main(String[] args) {
        // For this assignment, we need to compute rational values.
        // Fortunately, we've written a class (Rational.java) to help us!

        int decimals = Integer.parseInt(args[0]);
        Rational result = new Rational(0, 1);
        for(int i = 0; i < decimals; i++) {
            // First accumulate everything that goes inside the parenthesis
            Rational acc = new Rational(4, 8 * i + 1);
            acc = acc.sub(new Rational(2, 8 * i + 4));
            acc = acc.sub(new Rational(1, 8 * i + 5));
            acc = acc.sub(new Rational(1, 8 * i + 6));

            // Now, multiply it with 1/(16^i). For this, we need a pow method in Rational.
            acc = acc.multiply(new Rational(1, 16).pow(i));

            // Finally, add the accumulating part to the result.
            result = result.add(acc);
        }

        // Our approximation is 3.1415926535..., but we need the decimal part; so subtract 3.
        result = result.sub(new Rational(3, 1));

        // result is now the decimal part, i.e. 0.1415926535..., but to get the needed decimals,
        // we need to multiply it with (10^decimals)  (Remember; integer division)
        result = result.multiply(new Rational(10, 1).pow(decimals));

        // Now, let's print it!
        System.out.println("Pi = 3." + result.floorIntegerAsString() + "...");
    }
}
